; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include textbar.inc        ; local includes for this file

      text_bar PROTO :DWORD

.code

start:

; 

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   FUNC(GetModuleHandle, NULL)
      mov CommandLine, FUNC(GetCommandLine)
      mov hIcon,       FUNC(LoadIcon,hInstance,500)
      mov hCursor,     FUNC(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        FUNC(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        FUNC(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"Prostart_Class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

  ; -------------------------------------------------
  ; macro to autoscale window co-ordinates to screen
  ; percentages and centre window at those sizes.
  ; -------------------------------------------------
    AutoScale 75, 70

    invoke CreateWindowEx,WS_EX_LEFT or WS_EX_ACCEPTFILES,
                          ADDR szClassName,
                          chr$("Demonstrate Text Bar"),
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

    mov eax, msg.wParam
    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL fname  :DWORD
    LOCAL patn   :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    Switch uMsg
      Case WM_COMMAND

        Switch wParam

          Case 50
            fn MessageBox,hWnd,str$(eax),"New",MB_OK
          Case 51
            fn MessageBox,hWnd,str$(eax),"Open",MB_OK
          Case 52
            fn MessageBox,hWnd,str$(eax),"Save",MB_OK
          Case 53
            fn MessageBox,hWnd,str$(eax),"Cut",MB_OK
          Case 54
            fn MessageBox,hWnd,str$(eax),"Copy",MB_OK
          Case 55
            fn MessageBox,hWnd,str$(eax),"Paste",MB_OK
          Case 56
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL

        ;======== menu commands ========

          Case 1001
            sas patn, "All files",0,"*.*",0
            mov fname, OpenFileDlg(hWin,hInstance,"Open File",patn)
            cmp BYTE PTR [eax], 0
            jne @F
            return 0
            @@:
          ; ---------------------------------
          ; perform your file open code here
          ; ---------------------------------
            invoke MessageBox,hWin,fname,ADDR szDisplayName,MB_OK

          Case 1002
            sas patn, "All files",0,"*.*",0
            mov fname, SaveFileDlg(hWin,hInstance,"Save File As ...",patn)
            cmp BYTE PTR [eax], 0
            jne @F
            return 0
            @@:
          ; ---------------------------------
          ; perform your file save code here
          ; ---------------------------------
            invoke MessageBox,hWin,fname,ADDR szDisplayName,MB_OK

          Case 1010
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL

          Case 1900
            ShellAboutBox hWin,hIcon,\
              "About Prostart 3 Template#Windows Application",\
              "Prostart 3 Template",13,10,"Copyright  MASM32 1998-2003"

          ;====== end menu commands ======
      Endsw

      Case WM_DROPFILES
        mov fname, DropFileName(wParam)
        fn MessageBox,hWin,fname,"WM_DROPFILES",MB_OK

      Case WM_CREATE

    ; ============================

        mov hTbar, FUNC(text_bar,hWin)

        fn CreateFont,16,6,0,0,500,0,0,0,DEFAULT_CHARSET, \
                      OUT_DEFAULT_PRECIS,PROOF_QUALITY, \
                      DEFAULT_PITCH or FF_DONTCARE, \
                      FF_DONTCARE,"Arial"
        mov hFont, eax

        invoke SendMessage,hTbar,WM_SETFONT,hFont,TRUE

    ; ============================

      Case WM_SYSCOLORCHANGE

      Case WM_SIZE

      Case WM_CLOSE
        invoke DeleteObject,hFont

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

; 

text_bar proc hParent:DWORD

comment * --------------------------------------------
        TxtItem has 3 parameters,
        1. zero based text ID Items, must be sequential
        2. command ID for WM_COMMAND processing
        3. Quoted string to display on menu
        -------------------------------------------- *

    TB_BEGIN hParent

    TxtItem  0,  50, "New"
    TxtItem  1,  51, "Open"
    TxtItem  2,  52, "Save"
    TxtSeperator
    TxtItem  3,  53, "Cut"
    TxtItem  4,  54, "Copy"
    TxtItem  5,  55, "Paste"
    TxtSeperator
    TxtItem  6,  56, "Exit"

    TB_END

text_bar endp

; 

end start
